/*
 * Enemy1.java
 *
 * Last modified: <2008/08/22 09:07:07 +0900> By SUMIDA
 */
package game;

import static game.SystemInfo.*;
import static game.Ship.*;
import static game.Shot.*;
import static game.MyShip.*;
import static game.Enemy.*;
import static game.Real.*;
import static game.Logging.*;

public class Enemy1 implements EnemyModule {

    public void init(Ship.Info info) {

        trace(String.format("info=%s, id=%d", info, info.id));
        info.sprite.options |= 10;
        info.sprite.dy = IntToReal(1);
    }

    public void action(Ship.Info info) {

        switch (info.stat) {
        case SHIP_STAT_APPEAR:
            if (info.count < 0) {
                info.count = 5;
                info.stat = SHIP_STAT_MOVE;
            }
            break;

        case SHIP_STAT_MOVE:
            if (info.count < 0) {
                info.count = 5;
                info.stat = SHIP_STAT_NORMAL;
            }
            break;

        case SHIP_STAT_NORMAL:
            if (info.count < 0 && Random(0, 128) < SystemInfo.level) {
                info.count = 5;
                info.stat = SHIP_STAT_FIRE;
            }
            break;

        case SHIP_STAT_FIRE:
            if (info.count < 0 && Random(0, 128) < SystemInfo.level) {
                /* 狙い撃ち単発弾の発射 */
                Shot.Info shot = Shot.getInfo(enemy_shot_mgr, SHOT_ID_BALLET);

                if (shot != null) {
                    Shot.fire(shot, info, 0, 0);
                    Shot.homing(shot, ship, IntToReal(1));
                }

                info.count = 5;
                info.stat = SHIP_STAT_MOVE;
            }
            break;

        default:
            return;
        }

        /* 画面端で反転 */
        if (info.sprite.dx < 0 && info.sprite.x < IntToReal(10)
            || info.sprite.dx > 0 && info.sprite.x > IntToReal(WIDTH - 10)) {
            info.sprite.dx = -info.sprite.dx;
        }
    }

    public void term(Ship.Info info) {
        trace("info=" + info);
    }
}
