/*
 * Enemy5.java
 *
 * Last modified: <2008/08/22 09:26:19 +0900> By SUMIDA
 */
package game;

import static game.SystemInfo.*;
import static game.Ship.*;
import static game.MyShip.*;
import static game.Audio.*;
import static game.Real.*;
import static game.Logging.*;

public class Enemy5 implements EnemyModule {

    public void init(Ship.Info info) {

        trace(String.format("info=%s, id=%d", info, info.id));
        info.sprite.options |= 14;
        info.sprite.dy = IntToReal(1);
    }

    public void action(Ship.Info info) {

        switch (info.stat) {
        case SHIP_STAT_APPEAR:
            /* 自機側に方向変更 */
            if (info.sprite.x < ship.sprite.x && info.sprite.dx < 0
                || info.sprite.x > ship.sprite.x && info.sprite.dx > 0) {

                info.sprite.dx = -info.sprite.dx;
            }

            if (info.count < 0) {
                info.count = 5;
                info.stat = SHIP_STAT_MOVE;
            }
            break;

        case SHIP_STAT_MOVE:
            if (info.count < 0) {
                info.count = 5;
                info.stat = SHIP_STAT_NORMAL;
            }
            break;

        case SHIP_STAT_NORMAL:
            if (info.count < 0 && Random(0, 128) < SystemInfo.level) {
                info.count = 5;
                info.stat = SHIP_STAT_FIRE;
            }
            break;

        case SHIP_STAT_FIRE:
            if (info.count < 0 && Random(0, 128) < SystemInfo.level) {
                /* ミサイルの発射 */
                Ship.Info missile = Enemy.getInfo(SHIP_ID_MISSILE,
                                                  info.sprite.x + IntToReal(30-8),
                                                  info.sprite.y);

                if (missile != null) {

                    trace(String.format("info.sprite.x=%d, info.sprite.y=%d, missile.sprite.x=%d, missile.sprite.y=%d",
                                  info.sprite.x, info.sprite.y, missile.sprite.x, missile.sprite.y));
                    Sound.playEffect(SE_SHOT2);
                }

                info.count = 10;
                info.stat = SHIP_STAT_MOVE;
            }
            break;

        default:
            return;
        }
    }

    public void term(Ship.Info info) {
        trace("info=" + info);
    }
}
