/*
 * EnemyModule.java
 *
 * Last modified: <2008/08/22 00:47:45 +0900> By SUMIDA
 */
package game;

/**
 * 敵機制御モジュールを定義するインターフェース。
 */
public interface EnemyModule {

    /**
     * 敵機制御情報の初期化処理。
     * @param info 制御情報
     */
    void init(Ship.Info info);

    /**
     * 敵機制御情報の動作処理。
     * @param info 制御情報
     */
    void action(Ship.Info info);

    /**
     * 敵機制御情報の後始末処理。
     * @param info 制御情報
     */
    void term(Ship.Info info);
}
