/*
 * Missile.java
 *
 * Last modified: <2008/08/22 07:01:52 +0900> By SUMIDA
 */
package game;

import static game.SystemInfo.*;
import static game.MyShip.*;
import static game.Effect.*;
import static game.Real.*;
import static game.Logging.*;

public class Missile implements EnemyModule {

    public void init(Ship.Info info) {

        trace(String.format("info=%s, id=%d", info, info.id));
        info.sprite.options |= 15;
        info.sprite.dy = IntToReal(2);
    }

    public void action(Ship.Info info) {

        Surface.Info surface_info = Surface.getInfo(info.sprite.surface_id);
        Surface.Info surface_ship = Surface.getInfo(ship.sprite.surface_id);

        info.sprite.dx = 0;

        if (info.sprite.y < ship.sprite.y) {
            int x0 = info.sprite.x + (IntToReal(surface_info.frame_width) >> 1);
            int x1 = ship.sprite.x + (IntToReal(surface_ship.frame_width) >> 1);

            if (x0 < x1)
                info.sprite.dx = IntToReal(1);
            else if (x0 > x1)
                info.sprite.dx = -IntToReal(1);
        }

        if (info.count < 0) {
            Effect.Info effect = Effect.getInfo(EFFECT_ID_FIRE);

            if (effect != null) {
                Effect.setPosition(effect, info, 0, -IntToReal(25));
                effect.sprite.dx = IntToReal((int)Random(-2, 2));
                effect.sprite.dy = -IntToReal((int)Random(2, 4));
                info.count = 5;
            }
        }
    }

    public void term(Ship.Info info) {
        trace("info=" + info);
    }
}
