/*
 * MyShip.java
 *
 * Last modified: <2008/08/22 22:27:22 +0900> By SUMIDA
 */
package game;

import static game.SystemInfo.*;
import static game.Input.*;
import static game.Ship.*;
import static game.Shot.*;
import static game.Real.*;
import static game.Audio.*;

public class MyShip {

    public static final short SIDE_SPACE   = 30;
    public static final short BOTTOM_SPACE = 30;
/*
    public static final short FORCE_STORE_1    = 0x0001;
    public static final short FORCE_STORE_2    = 0x0002;
    public static final short FORCE_STORE_3    = 0x0004;
    public static final short FORCE_STORE_4    = 0x0008;
    public static final short FORCE_STORE_MAX  = 0x000F;
    public static final short FORCE_ATTACK     = 0x0010;
    public static final short FORCE_LEVEL_MAX  = 5;
    public static final short FORCE_LEVEL_UP   = 5;
*/
    public static Ship.Manager ship_mgr = new Ship.Manager();
    public static Shot.Manager ship_shot_mgr = new Shot.Manager();

    public static Ship.Info ship = null;

    /* 自機の初期化  */
    public static void init() {
        Ship.init(ship_mgr, SHIP_MAX);
        Shot.init(ship_shot_mgr, SHIP_SHOT_MAX);
        ship = Ship.getInfo(ship_mgr, SHIP_ID_ME);
        ship.sprite.x = IntToReal(WIDTH / 2 - 30);
        ship.sprite.y = IntToReal(HEIGHT    - 60);
    }

    /* 自機の制御 */
    public static void action() {

        /* 自機の操作 */
        if ((input[P1] & INPUT_PRESS_LEFT)  != 0) ship.sprite.x -= IntToReal(2);
        if ((input[P1] & INPUT_PRESS_RIGHT) != 0) ship.sprite.x += IntToReal(2);
        if ((input[P1] & INPUT_PRESS_UP)    != 0) ship.sprite.y -= IntToReal(2);
        if ((input[P1] & INPUT_PRESS_DOWN)  != 0) ship.sprite.y += IntToReal(2);

        if (ship.sprite.x < IntToReal(-SIDE_SPACE))           ship.sprite.x = IntToReal(-SIDE_SPACE);
        if (ship.sprite.x > IntToReal(WIDTH - SIDE_SPACE))    ship.sprite.x = IntToReal(WIDTH - 30);
        if (ship.sprite.y < 0)                                ship.sprite.y = 0;
        if (ship.sprite.y > IntToReal(HEIGHT - BOTTOM_SPACE)) ship.sprite.y = IntToReal(HEIGHT - BOTTOM_SPACE);

        if ((input[P1] & INPUT_REPEAT_BUTTON1) != 0 && ship.stat != SHIP_STAT_LOST) {
            Shot.Info shot = Shot.getInfo(ship_shot_mgr, SHOT_ID_NORMAL);
            if (shot != null) {
                Shot.fire(shot, ship, 0, -32);
                shot.sprite.dy = IntToReal(-16);
            }
        }

        /* スプライトの制御 */
        Sprite.action(ship.sprite);

        /* 状況に応じた制御 */
        switch (ship.stat) {
        case SHIP_STAT_EXPLOSION:
            if (ship.count == 0) {
                Sound.stopEffect();
            }
            Sound.playEffect(SE_BOMB2);
            if (ship.count++ > 2) {
                ship.stat = SHIP_STAT_LOST;
                SystemInfo.status = SYSTEM_MODE_OVER;
                Sound.playMusic(BGM_OVER, -1);
            }
            break;
        }

        /* スプライトの表示 */
        if (ship.stat != SHIP_STAT_LOST) {
            Sprite.put(ship.sprite);
        }
    }
}
